import { system } from 'mojang-minecraft'
import * as ui from 'mojang-minecraft-ui'
import { world } from 'mojang-minecraft'
import { ActionFormData, ModalFormData } from "mojang-minecraft-ui"

let element = new ui.ActionFormData()
element.title("Elements")
element.body("Select the element which you want NOTE:You can only have 1 element at a time")//Starts at 0
element.button("§cFire")
element.button("§4Earth")
element.button("§1Water")
element.button("§7Wind")


world.events.beforeItemUse.subscribe(eventData => {
    let player = eventData.source
    let item = eventData.item
    if (item.id == "zen:element_picker") {
        element.show(player).then(result => {
            let selection = result.selection
            if (selection == 0) {
                player.runCommand("function hastagfire")
                player.runCommand('tag @s add fire')
                player.runCommand('clear @s zen:element_picker 0 1')
                player.runCommand('function fire')
                player.runCommand('tellraw @s {"rawtext":[{"text":"Your Elemental power is now §cFire"}]}')
                player.runCommand('playsound fire.ignite @s ~~~')
            }
            if (selection == 1) {
                player.runCommand("function hastagearth")
                player.runCommand('tag @s add earth')
                player.runCommand('clear @s zen:element_picker 0 1')
                player.runCommand('function earth')
                player.runCommand('tellraw @s {"rawtext":[{"text":"Your Elemental power is now §4Earth"}]}')
                player.runCommand('playsound random.explode @s ~~~')
            }
            if (selection == 2) {
                player.runCommand("function hastagwater")
                player.runCommand('tag @s add water')
                player.runCommand('clear @s zen:element_picker 0 1')
                player.runCommand('function water')
                player.runCommand('tellraw @s {"rawtext":[{"text":"Your Elemental power is now §1Water"}]}')
                player.runCommand('playsound bucket.fill_water @s ~~~')
            }
            if (selection == 3) {
                player.runCommand("function hastagwind")
                player.runCommand('tag @s add wind')
                player.runCommand('clear @s zen:element_picker 0 1')
                player.runCommand('function wind')
                player.runCommand('tellraw @s {"rawtext":[{"text":"Your Elemental power is now §7Wind"}]}')
                player.runCommand('playsound item.trident.throw @s ~~~')
            }


        })
    }
});


class loreItem {
    constructor(itemId, lore) {
        this.itemId = itemId;
        this.lore = lore;
    }
}

const ItemArray = [
    new loreItem("zen:fire_netherite_sword", [" §fLevel 1 \n §2Abilities: \n    §cFire Guard \n §dkill mobs and use magic to level up"]),
    new loreItem("zen:wind_netherite_sword", [" §fLevel 1 \n §2Abilities: \n    §7Wind Launch \n §duse magic to level up"]),
    new loreItem("zen:earth_netherite_sword", [" §fLevel 1 \n §2Abilities: \n    §0Obsidian Cage \n §dkill mobs and use magic to level up"]),
    new loreItem("zen:water_netherite_sword", [" §fLevel 1 \n §2Abilities: \n    §1Water Cage \n §dkill mobs and use magic to level up"]),
    new loreItem("zen:earth_netherite_sword2", [" §fLevel 2 \n §2Abilities: \n    §0Obsidian Cage \n    §4Ground Breaker Punch \n §duse magic to level up"]),
    new loreItem("zen:fire_netherite_sword2", [" §fLevel 2 \n §2Abilities: \n    §cFire Guard \n    §2Poison \n §duse magic to level up"]),
    new loreItem("zen:water_netherite_sword2", [" §fLevel 2 \n §2Abilities: \n    §1Water Cage \n    §cDamage+ \n §duse magic to level up"]),
    new loreItem("zen:wind_netherite_sword2", [" §fLevel 2 \n §2Abilities: \n    §7Wind Launch \n    §cSlowness \n §duse magic to level up"]),
    new loreItem("zen:water_netherite_sword3", [" §fLevel 3 \n §2Abilities: \n    §1Water Cage \n    §cDamage+ \n    §5Telekinesis"]),
    new loreItem("zen:wind_netherite_sword3", [" §fLevel 3 \n §2Abilities: \n    §7Wind Launch \n    §cSlowness \n    §7Wind Push"]),
    new loreItem("zen:earth_netherite_sword3", [" §fLevel 3 \n §2Abilities: \n    §0Obsidian Cage \n    §4Ground Breaker Punch \n    §eStriking"]),
    new loreItem("zen:fire_netherite_sword3", [" §fLevel 3 \n §2Abilities: \n    §cFire Guard \n    §2Poison \n    §cFlare Charge"]),
];

world.events.tick.subscribe(() => {
    for (const player of world.getPlayers()) {
        const playerContainer = player.getComponent("inventory").container
        for (let i = 0; i < playerContainer.size; i++) {
            const item = playerContainer.getItem(i);
            const findLore = ItemArray.find(x => x.itemId == item?.id);
            const lore = item?.getLore();
            if (!findLore || !item || lore?.length != 0) continue
            item.setLore(findLore.lore);
            playerContainer.setItem(i, item);
        }
    }
});




let config_ele = new ui.ActionFormData()
config_ele.title("Configure your element")
config_ele.button("Effects on/off")
config_ele.button("Particles on/off")
config_ele.button("Super Art on/off")



world.events.beforeItemUse.subscribe(eventData => {
    let player = eventData.source
    let item = eventData.item
    if (item.id == "zen:controller") {
        config_ele.show(player).then(result => {
            let selection = result.selection
            if (selection == 0) {
                if (player.hasTag("effect"))
                    player.runCommand("tag @s remove effect"),
                        player.runCommand('tellraw @s {"rawtext":[{"text":"Effects turned off"}]}')

                else
                    player.runCommand("tag @s add effect"),
                        player.runCommand('tellraw @s {"rawtext":[{"text":"Effects turned on"}]}')
            }
            if (selection == 1) {
                if (player.hasTag("particle"))
                    player.runCommand("tag @s remove particle"),
                        player.runCommand('tellraw @s {"rawtext":[{"text":"Particles turned off"}]}')

                else
                    player.runCommand("tag @s add particle"),
                        player.runCommand('tellraw @s {"rawtext":[{"text":"Particles turned on"}]}')
            }
            if (selection == 2) {
                if (player.hasTag("super"))
                    player.runCommand("tag @s remove super"),
                        player.runCommand('tellraw @s {"rawtext":[{"text":"Super Art turned off"}]}')

                else
                    player.runCommand("tag @s add super"),
                        player.runCommand('tellraw @s {"rawtext":[{"text":"Super Art turned on"}]}')
            }

        })
    }
});

system.events.beforeWatchdogTerminate.subscribe(event => {
    event.cancel = true
});






//const fire_con = new ModalFormData()
//fire_con.title("Configure your element")
//fire_con.toggle("Effects")
//fire_con.toggle("Particles")
//fire_con.toggle("Super art")


//world.events.beforeItemUse.subscribe(eventData => {
 //   if (eventData.item.id == 'minecraft:compass') {
   //     const player = eventData.source
     //   fire_con.show(player).then(result => {
       //     if (result.formValues[0] == true) {
         //       player.runCommand('tag @s add effect')
           // }
        //    if (result.formValues[0] == false) {
          //      player.runCommand('tag @s remove effect')
           // }
            //if (result.formValues[1] == true) {
           //     player.runCommand('tag @s add particle')
//            }
  //          if (result.formValues[1] == false) {
    //            player.runCommand('tag @s remove particle')
      //      }
        //    if (result.formValues[2] == true) {
          //      player.runCommand('tag @s add super')
          //  }
            //if (result.formValues[2] == false) {
             //   player.runCommand('tag @s remove super')
           // }
 //       }
//
//
  //      )

  //  }
//});

